//************************************************************************
// Datei: savetext.c
//
// Speichert den Textschirm eines T6963 Displays als Textdatei.
//
// Die Routinen sind fr ein 240x64 Display ausgelegt.
// 128x64 habe ich nie probiert. Das wird mit dem 6 Bit Modus wohl noch
// ziemlich buggy sein. Im 8 Bit Modus sollte es keine Probleme geben.
// 
// hk@holger-klabunde.de
// http://www.holger-klabunde.de
// 11.02.2007
// Compiler AVR-GCC 3.4.6
//************************************************************************
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <stdlib.h>
#include <portbits.h>



#include "param.h"

#include "fontsoftape.h"

//*****INCLUD-FILES FOR SD-CARD*********
#include "dos.h"			
#include "fat.h"			
#include "dosdefs.h"						
#include "mmc_spi.h"
#include "find_x.h"		
#include "savetext.h"
//*****INCLUD-FILES FOR SD-CARD*********


//#############################################################
// Display saving routine. 
// Returns 0 if failed, >0 if successfull
//
// This routine only saves the Text screen ! Not the text
// AND graphic screen you might see on your display.
//
// Diese Routine speichert nur den Textschirm ! Nicht die
// Mischung aus Text und Grafik die man mglicherweise auf dem
// Display sieht.
//
//###################################################################################
//STRING-IN-DATEI-SCHREIBEN !!      dateiname     string
unsigned char SaveTextDisplay(char *name,char *__putstr)
//###################################################################################
{
 char __ps;
 unsigned char by, result;

 
 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   // Gib hier eine Fehlermeldung raus
     LCDSoftText("KEINE SD-CARD GEFUNDEN",1,1); 
  // while(1);
  }
           if(Fopen(name,'a')!=F_OK) return 0;
           {

 while((__ps = *__putstr))
  {
   __putstr++;
   if (__ps== 0) break;

     
     result=Fwrite(&__ps,1);
    } //for j
   by='\r';
   result=Fwrite(&by,1);
   by='\n';
   result=Fwrite(&by,1);


 Fclose();
 LCDSoftText("DATEI GESCHRIEBEN text",1,1); 
 return result;
}
}



//###################################################################################
//STRING-IN-DATEI-SCHREIBEN !!      dateiname     variable
unsigned char SaveTextDisplay_c(char *name,unsigned char c)
//###################################################################################
{
 unsigned char by;
 unsigned char da, result;
da=c;
 
 unsigned int buf=da;
 char string[10];
 unsigned int written;
 utoa ( buf,string,10);
 
 
 
 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   // Gib hier eine Fehlermeldung raus
     LCDSoftText("KEINE SD-CARD GEFUNDEN",1,1); 
  // while(1);
  }
           if(Fopen(name,'a')!=F_OK) return 0;
           {



                written=Fwrite((unsigned char *)string,strlen(string));  
    // result=Fwrite(&da,1);
   by='\%';
   result=Fwrite(&by,1);
   by='\r';
   result=Fwrite(&by,1);
   by='\n';
   result=Fwrite(&by,1);

//} //
 Fclose();
 LCDSoftText("DATEI GESCHRIEBEN PwM",1,1); 
 return result;
}
}

//###################################################################################
//TEST-DATEI-lesen und auf Diplay schreiben !!
unsigned char LoadTextDisplay()
//###################################################################################
{

//TEST DATEI ANLEGEN GEHT ERSTMAL 
 unsigned int buf=111111111111111111111;//=12345;
 char string[11];
 unsigned int reading;
 utoa ( buf,string,11);
 
 if(GetDriveInformation()!=F_OK) // get drive parameters
  {
   // Gib hier eine Fehlermeldung raus
     LCDSoftText("KEINE SD-CARD GEFUNDEN",1,1); 
  // while(1);
  }
           if(Fopen("test.txt",F_READ)!=F_OK) return 0;
           {



            reading=Fread((unsigned char *)string,strlen(string));        // Puffer in SD schreiben
           
			LCDSoftText(string,1,100);  //TEST-DATEI-lesen und auf Diplay schreiben !!
			
			
			Fclose(); //Datei schliessen
			
           }
}



//###################################################################################
//STRING-IN-DATEI-SCHREIBEN !!      dateiname     variable
//unsigned char LoadTextDisplay_c(char *name,unsigned char c)
unsigned char LoadTextDisplay_xy( char *name)


//###################################################################################
{
//// unsigned int buf=1111111111111;//=12345;
// char string[20];
//  unsigned int reading;
//// utoa ( buf,string,14);

// if(GetDriveInformation()!=F_OK) // get drive parameters
//  {
//   // Gib hier eine Fehlermeldung raus
//     LCDSoftText("KEINE SD-CARD GEFUNDEN",1,1); 
 
//  }
//           if(Fopen(name,'a')!=F_OK) return 0;
//           {
//             reading=Fread((unsigned char *)string,strlen(string)); 
//               LCDSoftText(string,1,20);  //TEST-DATEI-lesen und auf Diplay schreiben !!
//
// Fclose();
//}
//}





//***************************************************************************
//Funktion:  Liest eine bestimmte Anzahl Bytes aus einer Datei in einen
//           Puffer
//
//Parameter: "buf" Zeiger auf den Puffer wo die Daten rein sollen
//           "numbytes" Anzahl der Bytes die gelesen werden sollen
//
//Rckgabe:  Anzahl der Bytes die gelesen wurden
//           
//Beispiel: 11 Bytes lesen


          unsigned char inbuff[21];
          unsigned char by;
          unsigned int readbytes;
 
     
          if(GetDriveInformation()!=F_OK) // get drive parameters
         {
         // Gib hier eine Fehlermeldung raus
            LCDSoftText("KEINE SD-CARD GEFUNDEN",3,3); 
 
         }  
		  if(Fopen(name,F_READ)!=F_OK); // return 0;
          //if(Fopen("test.txt",F_READ)!=F_OK); //return 0;
           {
            readbytes=Fread(inbuff,21);
            readbytes=Fread(&by,1);      //Achte auf das & vor by !
            
			LCDSoftText(&by,1,200);      //TEST-DATEI-lesen und auf Diplay schreiben !!
			
			Fclose();                    //Datei Schliessen
           } 
    }
 //         Wenn das Dateiende erreicht ist liefert Fread() die Anzahl
 //         bis zum Dateiende gelesener Bytes oder einfach eine 0.









//###################################################################################
  unsigned char LoadTextDisplay_xpyp(char *name, unsigned short xpos, unsigned short ypos)
//###################################################################################
//***************************************************************************
//Funktion:  Liest eine bestimmte Anzahl Bytes aus einer Datei in einen
//           Puffer
//
//Parameter: "buf" Zeiger auf den Puffer wo die Daten rein sollen
//           "numbytes" Anzahl der Bytes die gelesen werden sollen
//
//Rckgabe:  Anzahl der Bytes die gelesen wurden
//           
//Beispiel: 11 Bytes lesen
{


          unsigned char inbuff[21];
          unsigned char by;
          unsigned int readbytes;
 
     
          if(GetDriveInformation()!=F_OK) // get drive parameters
         {
         // Gib hier eine Fehlermeldung raus
            LCDSoftText("KEINE SD-CARD GEFUNDEN",3,3); 
          }  
		  if(Fopen(name,F_READ)!=F_OK);
          
           {
            readbytes=Fread(inbuff,21);
            readbytes=Fread(&by,1);      //Achte auf das & vor by !
            
			LCDSoftText(&by,xpos,ypos);  //Lesen und auf Diplay schreiben !!
			
			Fclose();                    //Datei Schliessen
           } 
    }
 //         Wenn das Dateiende erreicht ist liefert Fread() die Anzahl
 //         bis zum Dateiende gelesener Bytes oder einfach eine 0.

//###################################################################################
//###################################################################################



